    	TTL tFIQhand.s	test FIQ handler
    	; ---------------------------------------------------------------------

    	AREA	tFIQhandler,PIC,CODE,READONLY,REENTRANT
    	EXPORT	testFIQhandler

testFIQhandler
    	; in:  FIQ32 mode; FIQs disabled
    	;      r14_fiq = interrupted address
    	;      r14_spsr = PSR of interrupted thread
        ;      r8_fiq..r13_fiq undefined
    	; out: no conditions

    	LDR 	r8,privdata 	    	; internal PC relative load
    	B   	FIQexit	    	    	; branch to check copyfn
    	MOV 	r8,r8	    	    	; NOP
FIQexit
    	SUBS	pc,r14,#4
privdata
    	DCD 	0x12345678
testFIQhandler_end

sizeof_code *	(testFIQhandler_end - testFIQhandler)

    	; ---------------------------------------------------------------------

	EXPORT	genFIQ
genFIQ
	STMFD	sp!,{r4,lr}
	MRS	r4,cpsr		; get current PSR description
	SWI	0x300036	; TRAP_EnterSVCMode : NASTY CONSTANT BODGE
				; We are now executing in SVC mode
	MOV	r0,#0xD1	; FIQ32 mode, FIQ and IRQ disabled
	MSR	cpsr,r0		; enter FIQ32 mode
				; We are now executing in FIQ32 mode
	MOV	r0,#0x1C	; Address of the FIQ vector
	MSR	spsr,r4		; CPSR state we want to return to
    	ADD 	lr,pc,#4    	; Remember FIQ returns using -4
	MOV	pc,r0		; Enter the FIQ vector
	; We return to this point back in our original mode
	LDMFD	sp!,{r4,pc}

    	; ---------------------------------------------------------------------

    	AREA	tFIQdata,DATA,READONLY
    	EXPORT	testFIQhandler_size
testFIQhandler_size
    	DCD 	sizeof_code

    	; ---------------------------------------------------------------------

; If we need to import symbols, we create slots in our data area to
; hold their address:
;    	     AREA	sb_tFIQ,DATA,READONLY,BASED r9
;   	     IMPORT	example
; adr_symbol DCD	example

    	; ---------------------------------------------------------------------
    	END
