#ifndef __keyboard_h
#define __keyboard_h

/*{{{  Header */

/*------------------------------------------------------------------------
--                                                                      --
--                     H E L I O S			                --
--                     -----------                                      --
--                                                                      --
--             Copyright (C) 1990, Perihelion Software Ltd.             --
--         Copyright (c) 1994, Perihelion Distributed Software.         --
--                        All Rights Reserved.                          --
--                                                                      --
-- keyboard.h								--
--                                                                      --
--	Header file defining Keyboard DCB structure.			--
--                                                                      --
--	Author:  BLV 21.2.90						--
--                                                                      --
------------------------------------------------------------------------*/

/*}}}*/
/*{{{  Includes */

#ifndef __helios_h
#include <helios.h>
#endif

#ifdef __TRAN
#ifndef __event_h
#include <event.h>
#endif
#else
#ifndef __intr_h
#include <intr.h>
#endif
#endif

#ifndef __link_h
#include <link.h>
#endif

/*}}}*/
/*{{{  Types */

typedef struct IntrStruct
  {
    Semaphore	wait;
    IntrHandler	handler;
  }
IntrStruct;

typedef struct LinkStruct
  {
    bool	running;
  }
LinkStruct;

typedef struct KeyboardDCB
  {
    DCB			DCB;
    VoidFnPtr		ReceiveKey;
    word		rc;
    union
      {
	LinkStruct	Link;
	IntrStruct	Intr;
      }
    Device;
  }
KeyboardDCB;

/*}}}*/

#endif /* __keyboard_h */
